<?php
//
// Configurateur Squelette Epona - 2005 Oct 5 - Marc Lebas.
//

function avertir($msg) {echo "<font color=orange>$msg</font><br>";}

function marque_erreur($msg) {
  global $erreur;
  echo "<b><font color=red>$msg</font></b><br>";
  $erreur = 1;
}

function dossier_squelettes() {
  if (!isset($GLOBALS['dossier_squelettes'])) {
    marque_erreur ('GLOBALS[dossier_squelettes] non dfini');
    return FALSE;
  }
  if (!file_exists("../".$GLOBALS['dossier_squelettes'])) {
    marque_erreur ("dossier squelette ../".$GLOBALS['dossier_squelettes']." non trouv");
    return FALSE;
  }
  if (!is_writable("../".$GLOBALS['dossier_squelettes'])) {
    marque_erreur("Pas d'accs en criture dans le rpertoire ../".$GLOBALS['dossier_squelettes']);
    return FALSE;
  }
  if (!file_exists("../".$GLOBALS['dossier_squelettes']."/inc-menu.html"))
      avertir("../".$GLOBALS['dossier_squelettes']."/inc-menu.html non trouv");
  if (!file_exists("../".$GLOBALS['dossier_squelettes']."/inc-menu_def.html"))
      avertir("../".$GLOBALS['dossier_squelettes']."/inc-menu_def.html non trouv");
  if (!is_writable("../".$GLOBALS['dossier_squelettes'].'/inc-menu.html'))
      avertir("Pas d'accs en criture pour ../".$GLOBALS['dossier_squelettes'].'/inc-menu.html');
  return TRUE;
}

function cree_menu_rub($fw, $prub, $indent, $differ) {
  // Fonction rcursive parcourant la hirarchie de rubriques publies
  // pour gnrer la hirarchie du menu droulant
  // fw = fichier, prub = rubrique parente, indent = indentation, differ = fermeture li
  $result = spip_query("SELECT id_rubrique, titre, statut FROM spip_rubriques WHERE id_parent=$prub AND statut='publie' AND titre!='Agenda' ORDER BY titre");
  while ($row = spip_fetch_array($result)) {
    if (!isset($found) && $prub != 0) fputs ($fw, " class=smenu$differ\n$indent<ul>\n"); 
    $found = 1;
    $titre=texte_script($row['titre']);
    $id_rub=$row['id_rubrique'];
    fputs ($fw, "$indent   <li");
   // on differe la fermeture du <li en memorisant le <a>...</a> pour pouvoir ajouter un eventuel class=smenu
    $differ1="><a href=\"rubrique.php?id_rubrique=".$id_rub."\">".$row['titre']."</a>";
    cree_menu_rub($fw, intval($row['id_rubrique']), "$indent   ", $differ1);
  }
  if ($prub ==0)  return;
  if (isset($found)) { fputs ($fw, "$indent</ul>\n$indent");  } else {fputs($fw, "$differ") ;}
  fputs ($fw, "</li>\n");
}

//
// Fonctions pour mot-cls
//
function groupe_vide($titre) {
  if (id_groupe($titre) != 0) {
       marque_erreur("Le groupe $titre existe dj");
       return FALSE;
  }
  return TRUE;
}

function id_groupe($titre) {
  // leve une erreur si plusieurs
  $result = spip_query("SELECT id_groupe FROM spip_groupes_mots WHERE titre='$titre'");
  switch (spip_num_rows($result)) {
    case 0 : return 0;
    case 1 : while ($row = spip_fetch_array($result)) return $row['id_groupe'];
    default : 
      marque_erreur(spip_num_rows($result)." groupes $titre : ");
      while ($row = spip_fetch_array($result)) echo 'id_groupe= '.$row['id_groupe'].'<br>';
      return -1;
  }
}

function id_mot($titre, $type) {
  // leve une erreur si plusieurs
  $result = spip_query("SELECT id_mot, titre FROM spip_mots WHERE titre='$titre' AND type='$type'");
  switch (spip_num_rows($result)) {
    case 0 : return 0;
    case 1 : while ($row = spip_fetch_array($result)) return $row['id_mot'];
    default : 
      marque_erreur(spip_num_rows($result)." mots $titre pour groupe mot $type :");
      while ($row = spip_fetch_array($result)) echo 'id_mot= '.$row['id_mot'].' '.$row['titre'].'<br>';
      return -1;
  }
}

function active_groupe($groupe, $mots) {
  $id_groupe=id_groupe($groupe);
  if ($id_groupe != 0) return FALSE;
  //Cration groupe + mot-cls
  if (!spip_query("INSERT INTO spip_groupes_mots SET titre='$groupe', unseul='non', obligatoire='non',
                 articles='oui', breves='non', rubriques='non', syndic='oui',
                  minirezo='oui', comite='oui', forum='non'")) {
     marque_erreur("Erreur cration $groupe");
     return FALSE;
  }
  $id_groupe = spip_insert_id();
  foreach ($mots as $mot) {
    if (!spip_query("INSERT INTO spip_mots (type, titre, id_groupe) VALUES ('$groupe', '$mot', '$id_groupe')")) {
       marque_erreur("Erreur cration mot $mot dans groupe $groupe");
       return FALSE;
    }
    echo " $mot";
  }
  echo " (groupe mots $groupe cr)<br>";
  return TRUE;
}

function pre_desactive_groupe($titre) {
  // seulement pour vrifier que le groupe est libre
  $rcode = TRUE;
  $id_groupe=id_groupe($titre);
  if ($id_groupe == 0) return TRUE;
  if ($id_groupe == -1) return FALSE;
  $result = spip_query("SELECT id_mot, titre FROM spip_mots WHERE id_groupe=$id_groupe");
  while ($row = spip_fetch_array($result)) {
    if (!pre_desactive_mot($row['id_mot'], $row['titre'])) $rcode = FALSE;
  }
  return $rcode;
}

function desactive_groupe($titre) {
  // aucun contrle d'attachement; dj fait par pre_desactive_groupe
  $id_groupe=id_groupe($titre);
  if ($id_groupe == 0) return TRUE;
  if ($id_groupe == -1) return FALSE;
  $result = spip_query("SELECT id_mot, titre FROM spip_mots WHERE id_groupe=$id_groupe");
  while ($row = spip_fetch_array($result)) {
    spip_query("DELETE FROM spip_mots WHERE id_mot='".$row['id_mot']."'");
    foreach (array('breves', 'articles', 'rubriques', 'forum', 'syndic') as $elem)
      spip_query("DELETE FROM spip_mots_".$elem." WHERE id_mot=".$row['id_mot']);
    spip_query("DELETE FROM spip_index_mots WHERE id_mot=".$row['id_mot']);
    echo $row['titre'].' ';
  }
  spip_query("DELETE FROM spip_groupes_mots WHERE id_groupe='$id_groupe'");
  echo " (groupe mots $titre effac)<br>";
  return TRUE;
}

function pre_desactive_mot($id_mot, $titre) {
  // pour vrifier qu'un mot est libre
  $rcode = TRUE;
  foreach (array('breve', 'article', 'rubrique') as $elem) {
    $result = spip_query("SELECT id_".$elem." FROM spip_mots_".$elem."s WHERE id_mot=$id_mot");
    if ($row = spip_fetch_array($result)) {
      avertir("Le mot-cl $titre est attach ($elem)");
      $rcode = FALSE;
    }
  }
  foreach (array('forum', 'syndic') as $elem) {
    $result = spip_query("SELECT id_".$elem." FROM spip_mots_".$elem." WHERE id_mot=$id_mot");
    if ($row = spip_fetch_array($result)) {
      avertir("Le mot-cl $titre est attach ($elem)");
      $rcode = FALSE;
    }
  }
  return $rcode;
}

//
// fonctions agenda
//
function cree_secteur_agenda($genre) {
  if (id_agenda() != 0) {
    marque_erreur("Le secteur Agenda existe dj");
    return FALSE;
  }
  // cree le groupe Agenda
  $id_mot_agenda=cree_groupe_agenda($genre);
  if ($id_mot_agenda == 0) return FALSE;
  // cree secteur Agenda
  if (!spip_query("INSERT INTO spip_rubriques (titre, id_parent) VALUES ('Agenda', '0')")) {
     marque_erreur("Erreur cration secteur Agenda");
     return FALSE;
  }
  $id_rub_agenda = spip_insert_id();
  echo "Rubrique Agenda cre sous la racine<br>";
  // Liaison entre rubrique et mot-cl
  if (!spip_query("INSERT INTO spip_mots_rubriques (id_mot, id_rubrique) VALUES ('$id_mot_agenda', '$id_rub_agenda')")) {
     marque_erreur("Erreur liaison Agenda");
     return FALSE;
  }
  echo "Lien entre secteur Agenda et mot-cl '$genre'<br>";
  calculer_rubriques();
  return TRUE;
}

function cree_groupe_agenda($genre) {
  global $type_agenda;
  if (id_groupe('Agenda') != 0) {
    marque_erreur("Le groupe Agenda existe dj");
    return 0;
  }
  echo "Autorisation dates antrieures<br>";
  if (!spip_query("REPLACE spip_meta (nom, valeur) VALUES ('articles_redac', 'oui')")) {
     marque_erreur("Erreur autorisation dates antrieures");
     return 0;
  }
  echo "Cration groupe Agenda<br>";
  if(!spip_query("INSERT INTO spip_groupes_mots SET titre='Agenda', unseul='non', obligatoire='non',
                 articles='non', breves='non', rubriques='oui', syndic='non',
                  minirezo='oui', comite='non', forum='non'")) {
     marque_erreur("Erreur cration groupe Agenda");
     return 0;
  }
  $id_groupe_agenda = spip_insert_id();
  echo "Cration mot $genre dans groupe Agenda<br>";
  if (!spip_query("INSERT INTO spip_mots (type, titre, id_groupe) VALUES ('Agenda', '$genre', '$id_groupe_agenda')")) {
     marque_erreur("Erreur cration mot ".$genre." dans groupe Agenda");
     return 0;
  }
  $type_agenda=$genre;
  echo "Groupe mot Agenda cr<br>";
  return spip_insert_id();
}

function type_agenda() {
  $result = spip_query("SELECT titre, id_mot FROM spip_mots WHERE type='Agenda'");
  switch (spip_num_rows($result)) {
    case 0 :  return 'aucun';
    case 1 :
       while ($row = spip_fetch_array($result)) $type=$row['titre'];
       switch ($type) {
         case 'agenda_mot' :
         case 'agenda_complet' :
         case 'agenda_secteur' :
           return $type;
         default :
           avertir("Type agenda ".$type." inconnu>");
           return $type;
       }
    default : 
       avertir(spip_num_rows($result)." mot-cls pour groupe mot Agenda: ");
       while ($row = spip_fetch_array($result)) echo 'mot-cl : '.$row['titre'].' id_mot : '.$row['id_mot'].'<br>';
       return 'plusieurs';
  }
}

function id_agenda() {
  // leve une erreur si plusieurs
  $result = spip_query("SELECT id_rubrique FROM spip_rubriques WHERE titre='Agenda' AND id_parent=0");
  switch (spip_num_rows($result)) {
    case 0 :  return 0;
    case 1 :  while ($row = spip_fetch_array($result)) return $row['id_rubrique'];
    default : 
       marque_erreur(spip_num_rows($result)." secteurs Agenda: ");
       while ($row = spip_fetch_array($result)) echo 'id_rubrique : '.$row['id_rubrique'].'<br>';
       return -1;
  }
}

function pre_desactive_agenda() {
  $id_rubrique=id_agenda();
  if ($id_rubrique == 0) {return TRUE;}
  if ($id_rubrique == -1) {return FALSE;}
  if (!tester_rubrique_vide($id_rubrique)) {
     marque_erreur("Le secteur Agenda n'est pas vide ");
     return FALSE;
  }
  return TRUE;
}

function desactive_agenda() {
  // aucun contrle; dj fait par pre_desactive_agenda
  $id_rubrique=id_agenda();
  if ($id_rubrique > 0) {
    echo "Supprime secteur Agenda<br>";
    spip_query("DELETE FROM spip_mots_rubriques WHERE id_rubrique=$id_rubrique");
    spip_query("DELETE FROM spip_index_rubriques WHERE id_rubrique=$id_rubrique");
    spip_query("DELETE FROM spip_rubriques WHERE id_rubrique=$id_rubrique");
    calculer_rubriques();
  }
  desactive_groupe('Agenda');
  return TRUE;
}

//
// Les points d'entres sous Main
//
function menudef() {
  echo "<h1>Menu par dfaut</h1>";
  if (!dossier_squelettes()) return FALSE;
  if (!copy('../'.$GLOBALS['dossier_squelettes'].'/inc-menu_def.html', '../'.$GLOBALS['dossier_squelettes'].'/inc-menu.html')) {
     marque_erreur("chec copie ".$GLOBALS['dossier_squelettes'].'/inc-menu_def.html vers '.$GLOBALS['dossier_squelettes'].'/inc-menu.html');
     return FALSE;
  }
}

function calcul_menu($type_agenda) {
  echo "<h1>Calcul menu HTML</h1>";
  if (!dossier_squelettes()) return FALSE;
  if (!$fw=fopen ("../".$GLOBALS['dossier_squelettes']."/inc-menu.html","w")) {
    marque_erreur("Pas d'accs en criture pour ../".$GLOBALS['dossier_squelettes']."/inc-menu.html");
    return FALSE;
  }
  fputs ($fw, "<div style=\"margin-left: 10px\">\n<ul id=menu>\n");
  // item accueil
  fputs ($fw, "    <li><a href=sommaire.php>Accueil</a></li>\n");
  // item Agenda
  switch ($type_agenda) {
    case 'agenda_secteur' : 
    case 'agenda_complet' : 
       ereg("agenda_(.*)$", $type_agenda, $regs);
       $id_rub_agenda = id_agenda();
       if ($id_rub_agenda != 0) {
         $result = spip_query("SELECT id_mot FROM spip_mots WHERE type='Agenda'");
         if ($row = spip_fetch_array($result)) {
             $id_mot_agenda = $row['id_mot'];
             $result = spip_query("SELECT id_mot FROM spip_mots_rubriques WHERE id_mot=$id_mot_agenda AND id_rubrique=$id_rub_agenda");
             if ($row = spip_fetch_array($result)) {
               fputs ($fw, "    <li class=smenu><a href=\"page.php?fond=agen_mois".$regs[1]."&amp;id_rubrique=".$id_rub_agenda."\">Agenda</a>\n");
               fputs ($fw, "      <ul>\n");
               fputs ($fw, "      <li><a href=\"page.php?fond=agen_mois".$regs[1]."&amp;id_rubrique=".$id_rub_agenda."\">Agenda mensuel</a></li>\n");
               fputs ($fw, "      <li><a href=\"page.php?fond=agen_an".$regs[1]."&amp;id_rubrique=".$id_rub_agenda."\">Agenda annuel</a></li>\n");
               fputs ($fw, "      </ul>\n");
               fputs ($fw, "    </li>\n");
             }
         }
       }
       break;
    case 'agenda_mot' :
        fputs ($fw, "    <li class=smenu><a href=page.php?fond=agen_mois_mot>Agenda</a>\n");
        fputs ($fw, "      <ul>\n");
        fputs ($fw, "      <li><a href=page.php?fond=agen_mois_mot>Agenda mensuel</a></li>\n");
        fputs ($fw, "      <li><a href=page.php?fond=agen_an_mot>Agenda annuel</a></li>\n");
        fputs ($fw, "      </ul>\n");
        fputs ($fw, "    </li>\n");
  }
  // items rubriques
  cree_menu_rub($fw, 0, " ", "");
  // items de fin de menu
  fputs ($fw, "    <li><a href=page.php?fond=site>Le site</a>\n");
  fputs ($fw, "    <ul>\n");
  fputs ($fw, "      <li><a href=page.php?fond=articles>Tous les articles</a></li>\n");
  fputs ($fw, "      <li><a href=page.php?fond=site>L'quipe</a></li>\n");
  fputs ($fw, "      <li><a href=ecrire>Administration</a></li>\n");
  fputs ($fw, "    </ul>\n");
  fputs ($fw, "    <li><a href=plan.php>Plan du site</a></li>\n");
  fputs ($fw, "</ul>\n</div>");
  fclose($fw);
  echo "inc-menu.html recalcul<br>";
  return TRUE;
}

function mots_on() {
  echo "<h1>Cration mot-cls</h1>";
  if (!groupe_vide('Album')) return FALSE;
  if (!groupe_vide('Epona')) return FALSE;
  active_groupe('Album', array('album_simple', 'vignettes_image'));
  active_groupe('Epona',  array('cacher', 'sommaire'));
}

function mots_off() {
  echo "<h1>Suppression mot-cls</h1>";
  if (!pre_desactive_groupe('Epona')) {
    marque_erreur("Groupe 'Epona' encore attach");
    return FALSE;
  }
  if (!pre_desactive_groupe('Album')) {
    marque_erreur("Groupe 'Album' encore attach");
    return FALSE;
  }
  desactive_groupe('Album');
  desactive_groupe('Epona');
}

function agenda_secteur() {
  echo "<h1>Agenda secteur</h1>";
  if (!cree_secteur_agenda('agenda_secteur')) return;
}

function agenda_mot() {
  echo "<h1>Agenda mot</h1>";
  if (!groupe_vide('_Agenda')) return FALSE;
  // cree le groupe agenda
  if (cree_groupe_agenda('agenda_mot') == 0) return FALSE;
  //Cration groupe _Agenda + mot-cl
  if (!active_groupe('_Agenda', array())) {
     marque_erreur("Erreur cration groupe _Agenda");
     return FALSE;
  }
}

function agenda_complet() {
  echo "<h1>Agenda complet</h1>";
  if (!groupe_vide('_Agenda')) return FALSE;
  if (!cree_secteur_agenda('agenda_complet')) return;
  //Cration groupe _Agenda + mot-cl
  if (!active_groupe('_Agenda', array())) {
     marque_erreur("Erreur cration groupe _Agenda");
     return FALSE;
  }
}

function agenda_off($type_agenda) {
  global $type_agenda;
  echo "<h1>Suppression $type_agenda</h1>";
  switch ($type_agenda) {
    case 'agenda_secteur' : 
        if (!pre_desactive_agenda()) return;
        desactive_agenda() ;
        break;
    case 'agenda_complet' : 
        if (!pre_desactive_agenda()) return;
        if (!pre_desactive_groupe('_Agenda')) {
          marque_erreur("Groupe '_Agenda' encore attach");
          return;
        }
        desactive_groupe('_Agenda') ;
        desactive_agenda() ;
        break;
    case 'agenda_mot' :
        if (!pre_desactive_groupe('_Agenda')) {
          marque_erreur("Groupe '_Agenda' encore attach");
          return;
        }
        desactive_groupe('Agenda');
        desactive_groupe('_Agenda') ;
        break;
  }
  $type_agenda='aucun';
}

//
// Main - Point d'entre du programme
//
if (!file_exists("inc.php")) {
  marque_erreur("inc.php non trouv. Le fichier epona_conf.php a-t-il t plac dans le rpertoire ecrire ?");
  exit;
}
include ("inc.php");
include ("inc_presentation.php");
if (($connect_statut != "0minirezo")) {
  install_debut_html(_T('info_acces_refuse'));
  install_fin_html();
  exit;
}
install_debut_html("Configurateur Epona v3");
if (file_exists(_FILE_OPTIONS)) include(_FILE_OPTIONS);
//
// Affichage et arret si la base n'est pas coherente
//
foreach (array('Agenda', '_Agenda', 'Epona', 'Album') as $titre) id_groupe($titre);
foreach (array('agenda_secteur', 'agenda_mot', 'agenda_complet') as $titre) id_mot($titre, 'Agenda');
foreach (array('sommaire', 'cacher') as $titre) id_mot($titre, 'Epona');
foreach (array('album_simple', 'vignettes_image') as $titre) id_mot($titre, 'Album');
// ligne suivante pour Epona v2
id_mot('Agenda', 'Agenda');
$type_agenda=type_agenda();
id_agenda() ;
if (isset($erreur)) exit;
//
// Analyse et traitement requete
//
switch ($type_agenda) {
  case 'aucun' :
    switch ($action) {
      case 'agen_secteur' : agenda_secteur(); break;
      case 'agen_complet' : agenda_complet(); break;
      case 'agen_mot' : agenda_mot(); break;
    }
    break;
  case 'agenda_mot' :
  case 'agenda_complet' :
  case 'agenda_secteur' : if ($action == 'agenda_off') agenda_off($type_agenda);
}
if (id_groupe('Album') == 0 && id_groupe('Epona') == 0) {
  if ($action == 'mots_on') mots_on();
}
if (id_groupe('Album') > 0 && id_groupe('Epona') > 0) {
  if ($action == 'mots_off') mots_off();
}
switch ($action) {
  case 'menu' : calcul_menu($type_agenda); break;
  case 'menudef' : menudef(); break;
}
if (isset($erreur)) marque_erreur("<h1>Echec</h1>");
//
// Affichage menu
//
if ($type_agenda == 'aucun') {
  echo "<a href=\"epona_conf.php?action=agen_secteur\">Crer l'agenda secteur</a><br>";
  echo "<a href=\"epona_conf.php?action=agen_mot\">Crer l'agenda mot</a><br>";
  echo "<a href=\"epona_conf.php?action=agen_complet\">Crer l'agenda complet</a><br>";
}
if (id_groupe('Album') == 0 && id_groupe('Epona') == 0) {
  echo "<a href=\"epona_conf.php?action=mots_on\">Crer mot-cls Epona</a><br>";
}
echo "<a href=\"epona_conf.php?action=menu\">Crer un menu HTML</a><br>";
echo "<a href=\"epona_conf.php?action=menudef\">Rinstaller le menu de base</a><br>";
echo "<a href=../".$GLOBALS['dossier_squelettes']."/sql.txt>Infos pour configuration manuelle et optimisation</a><br>";
echo "<a href=../".$GLOBALS['dossier_squelettes']."/MODIFS.txt>Description des changements</a><br>";
echo '<a href="../sommaire.php?recalcul=oui">Aller  la page d\'accueil</a><br>';
//
// Affichage etat final
//
echo '<h3>Etat de la configuration:</h3>';
dossier_squelettes();
echo "Agenda :  $type_agenda<br>";
$id_rubrique = id_agenda();
if ($id_rubrique == 0) {echo "Rubrique Agenda : absente<br>";} else {
  echo "Rubrique Agenda : prsente<br>";
  if (!tester_rubrique_vide($id_rubrique)) avertir("Rubrique Agenda non vide");
}
foreach (array('Agenda', '_Agenda', 'Epona', 'Album') as $titre) {
  $id_groupe=id_groupe($titre);
  if ($id_groupe == 0) {echo  "Groupe ".$titre." : absent<br>";} else {
    echo  "Groupe ".$titre." : prsent<br>";
    pre_desactive_groupe($titre);
  }
}

install_fin_html();
?>
